#include "chdecl.h"
void CH_chcode_chimprove_literal(current, sched, cop)
#define ARGUMENTS 5
#include "chhead.h"
select: switch (SELECTOR) {
    case 0: goto c0;
    case 1: goto cb4;
    case 2: goto c5;
    case 3: goto c26;
    case 4: goto c27;
    case 5: goto c29;  }
c0:
/* block , 0 */
  if((ch_returncode = che_block(QUAL(0),sched)) != Normal)
     goto ch_raise_exception;
/* block , 1 */
  if((ch_returncode = che_block(QUAL(1),sched)) != Normal)
     goto ch_raise_exception;
  current->ip = 1;
cb4:
/* receive 3 0 */
  if ((ch_returncode = che_receive(DEF(3),DEF(0),sched)) != Normal)
     goto ch_raise_exception;
  return;
c5:
/* lookup_at 4 3.1 3.3 */
  if((ch_i = REF(3)DOT(3).value.integer) < 0 || ch_i >= (ch_t = 
    REF(3)DOT(1).value.table)->size) goto ch_notfound;
  (*(REF(4).tsdr)->finalize)(REF(4).value,F_DISCARD,sched);
  (*(ch_t->tbls[ORDER_TBL].des->lookup_at))
    (ch_t, ORDER_TBL, & REF(4).value,ch_i);
  REF(4).tsdr = qdatarepmap[ch_t->tsdr->number];
/* lookup_at 5 4.1 =(0) */
  if ( !((ch_t = REF(4)DOT(1).value.table)->size) ) goto ch_notfound;
  (*(REF(5).tsdr)->finalize)(REF(5).value,F_DISCARD,sched);
  (*(ch_t->tbls[ORDER_TBL].des->lookup_at))
    (ch_t, ORDER_TBL, & REF(5).value,0);
  REF(5).tsdr = qdatarepmap[ch_t->tsdr->number];
/* copy 6 5 */
  REF(6) = REF(5);
/* lookup_at 7 3.2 6 */
  if((ch_i = REF(6).value.integer) < 0 || ch_i >= (ch_t = REF(3)DOT(2).value
    .table)->size) goto ch_notfound;
  (*(REF(7).tsdr)->finalize)(REF(7).value,F_DISCARD,sched);
  (*(ch_t->tbls[ORDER_TBL].des->lookup_at))
    (ch_t, ORDER_TBL, & REF(7).value,ch_i);
  REF(7).tsdr = qdatarepmap[ch_t->tsdr->number];
/* lookup_at 8 7.0 =(0) */
  if ( !((ch_t = REF(7)DOT(0).value.table)->size) ) goto ch_notfound;
  (*(REF(8).tsdr)->finalize)(REF(8).value,F_DISCARD,sched);
  (*(ch_t->tbls[ORDER_TBL].des->lookup_at))
    (ch_t, ORDER_TBL, & REF(8).value,0);
  REF(8).tsdr = qdatarepmap[ch_t->tsdr->number];
/* copy 9 8 */
  REF(9) = REF(8);
/* ilt . 9 =(3) , 23 */
  if ( REF(9).value.integer < 3 ) goto c23;
/* notequal . 7.2 =(1) , 23 */
  if ( REF(7)DOT(2).value.integer != 1 ) goto c23;
/* notequal . 7.3 =(1) , 23 */
  if ( REF(7)DOT(3).value.integer != 1 ) goto c23;
/* exit , 2 */
  ch_e = handler_type__exit; ch_val = QUAL(2); goto ch_exception;
c23:
/* return 3 */
  if (ch_caller = do_return(REF(3).value)) {
    if (ch_caller->type < CProcess) ch_caller->ip++;
      sched->wakeup_proc(sched, ch_caller);}
  else rem_return(REF(3).value);
  REF(3).tsdr = & dr_bottom;
/* endblock */
  che_endblock(sched);
/* branch , 27 */
   goto c27;
c26:
/* return_exception 3 , 3 */
  if (ch_caller = do_return(REF(3).value)) {
    raise_user(QUAL(3),ch_caller); 
    sched->wakeup_proc(sched,ch_caller);}
  else rem_return_exception(DEF(3),QUAL(3));
  REF(3).tsdr = & dr_bottom;
c27:
/* endblock */
  che_endblock(sched);
c29:
/* endprocess */
  che_endprocess(sched); return;
#include "chtail.h"
